#include "IOmqttSensor3.h"
#include "IOmgttSensor3_Configs.h"
#include "IOmqttSensor3_Sprache.h"

void setup() {
  Serial.begin(115200); // FÃ¼r Debuggingzwecke Ausgabe Ã¼ber Serielle Konsole
  Serial.println(String(IO_Setup_SystemStart));

  //----------
  fkt_ArduinoOta();
  fkt_displayInit();
  fkt_displayRowXY (11, 11, "System Boot");
  
  
  fkt_displayRowXY (1, 21, "WLAN: ");
  if (fkt_WifiConnect(SensorWlanSsid, SensorWlanPass)){
    fkt_displayRowXY (50, 21, "OK");
    fkt_displayRowXY (1, 31, "MQTT: ");
    var_IsMqttConnected = fkt_MqttConntect(MQTTServer, MQTTPort, MQTTUserName, MQTTUserPass);
    delay (100);
    if (var_IsMqttConnected) {
      fkt_MqttSubScribeSet();
      fkt_displayRowXY (50, 31, "OK");
    }
  }
  Serial.println(String(IO_Setup_SystemStartabgeschlossen));
  Serial.println(String(IO_Setup_SystemStartErstDatenErfassung));
  
  Value101Temperatur = float_fkt_getTemp();
  Value102Luftfeuchtigkeit = float_fkt_getHum();
  Value103Helligkeit = float_fkt_getLicht();
  Value107Barrometer = float_fkt_getLuftDruckBME();
  
  fkt_MqttPublishSet();
  fkt_displayRowXY (1, 41, "System Boot OK!");
  delay(200);
  fkt_displayClear();
  Serial.println(String(IO_Setup_SystemStartAbgeschlossen));
}

//Diese Variablen müssen für Temp missbraucht werden:
int int_var_TMP_Loop_Time_DHT = 0;
int int_var_TMP_Loop_Time_Analog = 0;
int int_var_TMP_Loop_Time_OLED = 0;
int int_var_TMP_Loop_Time_MQTTPUB = 0;

int int_var_TMP_ScreenSwitch=0;
void loop() {
  // put your main code here, to run repeatedly:
  int int_var_TMP_LaufZeitInSekunden = int_fkt_LaufZeitSekunden();
  
  if ( int_var_TMP_LaufZeitInSekunden - int_var_TMP_Loop_Time_DHT >= ((DHTSensorReadInt+BME280i2cReadInt)/2)){
    Serial.println("Lese TEMPERATUR");
    int_var_TMP_Loop_Time_DHT = int_var_TMP_LaufZeitInSekunden;
    
    Value101Temperatur = float_fkt_getTemp();
    Value102Luftfeuchtigkeit = float_fkt_getHum();
    Value107Barrometer = float_fkt_getLuftDruckBME();
  }
  if ( int_var_TMP_LaufZeitInSekunden - int_var_TMP_Loop_Time_Analog >= AnalogReadInt){
    Serial.println("Lese AnalogIn (LDR)");
    int_var_TMP_Loop_Time_Analog = int_var_TMP_LaufZeitInSekunden;
    Value103Helligkeit = float_fkt_getLicht();
  }

  if ( int_var_TMP_LaufZeitInSekunden - int_var_TMP_Loop_Time_OLED >= OLEDi2cReadInt){
    Serial.println("Zeit:"+Value301SystemZeit+";Datum:'"+Value302SystemDatum+";WifiStatus:"+String(fkt_WifiStatus())+";Uptime:"+String(int_fkt_LaufZeitSekunden())+";Temperatur:"+String(Value101Temperatur)+";Luftfeuchtigkeit:"+String(Value102Luftfeuchtigkeit)+";Barrometer:"+String(Value107Barrometer)+";Umgebungslicht:"+String(Value103Helligkeit));
    int_var_TMP_ScreenSwitch = int_var_TMP_ScreenSwitch + 1;

    int_var_TMP_Loop_Time_OLED = int_var_TMP_LaufZeitInSekunden;
    if (int_var_TMP_ScreenSwitch == 1) {
     //Screen 1
     fkt_displayClear();
     fkt_displayHead("Temperatur", Value101Temperatur);
     fkt_displayBigScreen(15, 15, Value301SystemZeit);
     fkt_displayMiddleScreen (4, 45, Value302SystemDatum);
    }
    if (int_var_TMP_ScreenSwitch == 2) {
     //Screen 2
     fkt_displayClear();
     fkt_displayDrawVertLine(45);
     fkt_displayHead("Datum", Value302SystemDatum);
     fkt_displayRowXY (1, 13, "Temper.");
     fkt_displayRowXY (1, 23, "C: ");
     fkt_displayMiddleScreen (50, 13, Value101Temperatur);
     fkt_displayRowXY (1, 35, "Luftf.");
     fkt_displayRowXY (1, 45, "%: ");
     fkt_displayMiddleScreen (50, 35, Value102Luftfeuchtigkeit);
    }
    if (int_var_TMP_ScreenSwitch == 3) {
     //Screen 3
     fkt_displayClear();
     fkt_displayDrawVertLine(30);
     fkt_displayHead("Uhr", Value301SystemZeit);
     fkt_displayRowXY (1, 13, "Bar: ");
     fkt_displayMiddleScreen (40, 13, Value107Barrometer);
     fkt_displayRowXY (1, 35, "LDR: ");
     fkt_displayMiddleScreen (40, 35, Value103Helligkeit);
    }
    if (int_var_TMP_ScreenSwitch >= 3){
      int_var_TMP_ScreenSwitch = 0;
    }
    int_var_TMP_Loop_Time_OLED = int_var_TMP_LaufZeitInSekunden;
  }

  if ( int_var_TMP_LaufZeitInSekunden - int_var_TMP_Loop_Time_MQTTPUB >= MQTTPublishZeit){
    int_var_TMP_Loop_Time_MQTTPUB = int_var_TMP_LaufZeitInSekunden;
    fkt_MqttPublishSet();
  }

  if (Value104_Bewegung != bool_Motiondetection()){
    Value104_Bewegung = bool_Motiondetection();
    var_MqttClient.publish(Value104.c_str(), String(Value104_Bewegung).c_str());
  }
 
  ArduinoOTA.handle();
  fkt_MqttClientLoop();
  //Serial.println("Zeit:"+Value301SystemZeit+";Datum:'"+Value302SystemDatum+";WifiStatus:"+String(fkt_WifiStatus())+";Uptime:"+String(int_fkt_LaufZeitSekunden())+";Temperatur:"+String(Value101Temperatur)+";Luftfeuchtigkeit:"+String(Value102Luftfeuchtigkeit)+";Barrometer:"+String(Value107Barrometer)+";Umgebungslicht:"+String(Value103Helligkeit));
  //Serial.println(WiFi.localIP());
  
}
