#include "IOmqttSensor3.h"
#include "IOmgttSensor3_Configs.h"
#include "IOmqttSensor3_Sprache.h"

int var_BME280i2cDetected = 0; 

void void_fkt_intialBME(){
  var_BME280i2c.parameter.communication = 0;
  var_BME280i2c.parameter.I2CAddress = BME280i2cAdresse;
  var_BME280i2c.parameter.sensorMode = 0b11; 
  var_BME280i2c.parameter.IIRfilter = 0b100; 
  var_BME280i2c.parameter.humidOversampling = 0b101;
  var_BME280i2c.parameter.tempOversampling = 0b101;  
  var_BME280i2c.parameter.pressOversampling = 0b101;
  var_BME280i2c.parameter.tempOutsideCelsius = BME280i2cTempDrausC;
  var_BME280i2c.parameter.tempOutsideFahrenheit = BME280i2cTempDrausF;
  var_BME280i2c.parameter.pressureSeaLevel = BME280i2cLuftDruck;

  if (var_BME280i2c.init() != 0x60)
  {    
    Serial.println(F("Kein BME280 Sensor"));
    var_BME280i2cDetected = 0;
  }
  else
  {
    //Serial.println(F("First BME280 Sensor detected!"));
    var_BME280i2cDetected = 1;
  }
  
}



/*
 * // [DE] Funktion wird in der u.A. in der Loop verwendet und soll NAN Werte abfangen. Nach 20 fehlerhaften Abfragen schickt er dennoch NAN
 * // [EN] Function will be used in Loop and should provide valide values.After 20 Error send NAN
 */
float float_fkt_getTempBME(){ 
  void_fkt_intialBME();
  if (var_BME280i2cDetected){
    return var_BME280i2c.readTempC();
  }
  else {
    return NULL;
  }
}


/*
 * // [DE] Funktion wird in der u.A. in der Loop verwendet und soll NAN Werte abfangen. Nach 20 fehlerhaften Abfragen schickt er dennoch NAN
 * // [EN] Function will be used in Loop and should provide valide values. After 20 Error send NAN
 */

float float_fkt_getHumBME(){     
  void_fkt_intialBME();
  if (var_BME280i2cDetected){
    return var_BME280i2c.readHumidity();
  }
  else {
    return NULL;
  }
}


/*
 * // [DE] Funktion wird in der u.A. in der Loop verwendet und soll NAN Werte abfangen. Nach 20 fehlerhaften Abfragen schickt er dennoch NAN
 * // [EN] Function will be used in Loop and should provide valide values. After 20 Error send NAN
 */

float float_fkt_getLuftDruckBME(){     
  void_fkt_intialBME();
  if (var_BME280i2cDetected){
    return var_BME280i2c.readPressure()-int(BME280i2cDruckKor);
  }
  else {
    return NULL;
  }
}
