#include "IOmqttSensor3.h"
#include "IOmgttSensor3_Configs.h"
#include "IOmqttSensor3_Sprache.h"

bool fkt_MqttConntect(const char* server, const int port , const char* user, const  char* pass) {
  var_MqttClient.setServer(server, port);
  var_MqttClient.setCallback(fkt_MqttCallback);
  int ConnectCounter = 0;
  Serial.println(String(IO_MQTT_Verbinde));
  while (!var_MqttClient.connected()) {
    if (var_MqttClient.connect(var_MqttSensorName.c_str(), user, pass)) {
      Serial.println("");
      Serial.println(String(IO_MQTT_Verbunden));
    } else {
      delay(1000);
      if (ConnectCounter > 15) {
        Serial.println(String(IO_MQTT_KeinMQTT));
        Serial.println(var_MqttClient.state());
        delay(5000);
        ESP.restart();
      }
      Serial.print("#");
    }
  }
  return true;
}

void fkt_MqttCallback(char* topic, byte* payload, unsigned int length) {
  pinMode(BUILTIN_LED, OUTPUT);
  digitalWrite(BUILTIN_LED, LOW);                           // Interne LED bei CALLBACK an
  Serial.println(topic);                                    // Zeige Topic auf Serial an.
  int PayloadLength = 0;                                    // Payloadlänge = 0;
  Serial.print("***********Message:");
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
    PayloadLength = i;                                      // Payloadlänge = Gezählt;
  }

  if (String(topic) == Value301) {                           // Wenn Topic SystenZeit ist
    Serial.println("*INFO:DO  :SystemZeit Topic Check");
    char *cstringZeit = (char *) payload;                   // Dann Caste irgendwas (inet Tip: https://github.com/knolleary/pubsubclient/issues/105)
    cstringZeit[PayloadLength + 1] = '\0';                  // Arrayende
    Value301SystemZeit = String(cstringZeit);            // Schreibe in Globale Variable
    Serial.println(String(cstringZeit));
  }
  if (String(topic) == Value302) {                            // Wenn Topic SystenDatum ist
    Serial.println("*INFO:DO  :System Datum Topic Check");
    char *cstringDatum = (char *) payload;                   // Dann Caste irgendwas (inet Tip: https://github.com/knolleary/pubsubclient/issues/105)
    cstringDatum[PayloadLength + 1] = '\0';                  // Arrayende
    Value302SystemDatum = String(cstringDatum);              // Schreibe in Globale Variable
    Serial.println(String(cstringDatum));
  }
  digitalWrite(BUILTIN_LED, HIGH);
}

void fkt_MqttSubScribeSet() {
  var_MqttClient.subscribe(Value301.c_str(), 1);            // Systemzeit vom Host
  var_MqttClient.subscribe(Value302.c_str(), 1);            // SystemDatum vom Host
}

void fkt_MqttPublishSet() {
  var_MqttClient.publish(Value101.c_str(), Value101Temperatur.c_str());             // S01_Temperatur
  var_MqttClient.publish(Value102.c_str(), Value102Luftfeuchtigkeit.c_str());       // S02_Luftfeuchtigkeit
  var_MqttClient.publish(Value103.c_str(), Value103Helligkeit.c_str());             // S03_Helligkeit
  var_MqttClient.publish(Value104.c_str(), String(Value104_Bewegung).c_str());      // S04_Bewegung
  var_MqttClient.publish(Value107.c_str(), Value107Barrometer.c_str());             // S07_Barrometer
  

  var_MqttClient.publish(Value201.c_str(), WiFi.localIP().toString().c_str());              // IP
  var_MqttClient.publish(Value202.c_str(), String(fkt_WifiProzent()).c_str());               // Signal
  var_MqttClient.publish(Value203.c_str(), Value301SystemZeit.c_str());                     // LastTimeStamp
  var_MqttClient.publish(Value206.c_str(), Value302SystemDatum.c_str());                     // LastTimeStampDatum
  var_MqttClient.publish(Value204.c_str(), String(int_fkt_LaufZeitSekunden()).c_str());     // RunInSecounds
   
}

void fkt_MqttClientLoop() {
  var_MqttClient.loop();
}

