#include "IOmqttSensor3.h"
#include "IOmgttSensor3_Configs.h"
#include "IOmqttSensor3_Sprache.h"

#define LOGO16_GLCD_HEIGHT 16 
#define LOGO16_GLCD_WIDTH  16 
#define OLED_RESET LED_BUILTIN
Adafruit_SSD1306 display(OLED_RESET);
#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2
#define SSD1306_LCDHEIGHT 64
#if (SSD1306_LCDHEIGHT != 64)
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif

void fkt_displayInit(){
  display.begin(SSD1306_SWITCHCAPVCC, OLEDi2cAdresse);
  fkt_displayClear();
  display.setCursor(0,1);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.println("IO MQTT SENSOR3");
  display.drawLine(0,10,127,10, WHITE);
  display.display();
}


void fkt_displayDrawVertLine(int xP){
  display.drawLine(xP,11,xP,64, WHITE);
  display.display();
}
void fkt_displayClear(){
  display.clearDisplay();
  display.display();
}

void fkt_displayHead(String var_Header, String var_Content){
  display.setCursor(0,1);
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.print(var_Header);
  display.print(":  ");
  display.print(var_Content);
  display.drawLine(0,10,127,10, WHITE);
  display.display();
}

void fkt_displayRowXY (int xP, int yP, String var_Content){
  display.setCursor(xP,yP);
  display.setTextSize(1);
  display.println(var_Content);
  display.display();
}

void fkt_displayMiddleScreen(int xP, int yP,String var_Content){
  display.setCursor(xP,yP);
  display.setTextSize(2);
  display.println(var_Content);
  display.display();
}

void fkt_displayBigScreen(int xP, int yP,String var_Content){
  display.setCursor(xP,yP);
  display.setTextSize(3);
  display.println(var_Content);
  display.display();
}

